/*
 * Lexical scanner for the burgomat grammar
 */

#ifndef __BURGOLEXER_H__
#define __BURGOLEXER_H__

#define TOKEN_NUMBER 0
#define TOKEN_QUANT 1
#define TOKEN_STRING 2
#define TOKEN_SPECIAL 3


struct lexer {
    char *input;
    int len;
    int offs;
    int row;
    int col;
};

struct token {
    int type;
    int val;
    char *string;
};

/* Functions */
struct lexer *lexer_init(char *input, int maxlen);
struct token *lexer_gettoken(struct lexer *lex);
void lexer_freetoken(struct token *token);
void lexer_destroy(struct lexer *lex);

#endif // __BURGOLEXER_H__
