/* Lexer test
 */

#include <stdio.h>
#include <stdlib.h>
#include "lexer.h"
#include "main.h"

void printattr(struct attrib *attr)
{
	while(attr) {
		printf("\t%d x %s @+%d\n", attr->quant, attr->info->name, 
			   attr->info->price);
		attr = attr->next;
	}
}

void main()
{
    struct lexer *lex;
	struct query *q;
	struct item *it;
    char buf[256];

    puts("Enter string");
    gets(buf);

    // lexer
    lex = lexer_init(buf, strlen(buf));
    q = parser(&menu, lex);
	lexer_destroy(lex);

	if (!q) {
		puts("no parsed data, you messed up");
		exit(0);
	}
	puts("Parse complete, analyzing");
	printf("Discount level %f(%s)\n", q->disc->frac, q->disc->name);

	it = q->items;
	while(it) {
		printf("%d x %s @ %d\n", it->quant, it->info->name, it->info->price);
		if (it->attr) printattr(it->attr);
		it = it->next;
	}
}



